<?php

/**
 * <pre>
 * Invision Power Services
 * IP.Board v3.4.2
 * Skin Functions
 * Last Updated: $Date: 2011-05-05 12:03:47 +0100 (Thu, 05 May 2011) $
 * </pre>
 *
 * Owner: Matt
 * @author 		$Author: ips_terabyte $
 * @copyright	(c) 2001 - 2009 Invision Power Services, Inc.
 * @license		http://www.invisionpower.com/company/standards.php#license
 * @package		IP.Board
 * @link		http://www.invisionpower.com
 * @since		9th March 2005 11:03
 * @version		$Revision: 8644 $
 *
 */

if ( ! defined( 'IN_IPB' ) )
{
	print "<h1>Incorrect access</h1>You cannot access this file directly. If you have recently upgraded, make sure you upgraded all the relevant files.";
	exit();
}

class skinGenerator extends skinCaching
{
	/**#@+
	 * Registry objects
	 *
	 * @access	protected
	 * @var		object
	 */
	protected $registry;
	protected $DB;
	protected $settings;
	protected $request;
	protected $lang;
	protected $member;
	protected $memberData;
	protected $cache;
	protected $caches;
	/**#@-*/


	/**
	 * Constructor
	 *
	 * @access	public
	 * @param	object		Registry object
	 * @return	@e void
	 */
	public function __construct( ipsRegistry $registry )
	{
		/* Make object */
		parent::__construct( $registry );
	}

	# i see a monster!

	/**
	 * Return JSON payload URL
	 * @return string Skin Generator URL
	 */
	// public function getJsonUrl()
	// {
	// 	$inDev = ( IN_DEV ) ? 1 : 0;

	// 	return 'http://ips-skin-gen.invisionpower.com/index.php?v=' . IPB_LONG_VERSION . '&k=' . urlencode( $this->settings['ipb_reg_number'] ) . '&i=' . $inDev;
	// }

	/**
	 * Delete a user's session
	 * @param int $skinSetId
	 */
	public function convertToFull( $skinSetId )
	{
		/* Current session? */
		$session = $this->getSessionBySkinId( $skinSetId );

		if ( $session['sg_member_id'] )
		{
			$this->deleteUserSession( $session['sg_member_id'] );
		}

		/* Tweak skin */
		$this->DB->update( 'skin_collections', array( 'set_by_skin_gen' => 0 ), 'set_id=' . $skinSetId );
	}


	/**
	 * Check to make sure we're GTG ...
	 */
	public function healthCheck()
	{
		$warnings = array();

		/* Can write into images */
		if ( ! is_writable( DOC_IPS_ROOT_PATH . PUBLIC_DIRECTORY . '/style_images' ) )
		{
			$warnings[] = 'Cannot write to image directory';
		}

		return ( count( $warnings ) ) ? $warnings : true;
	}

	/**
	 * Fetches the JSON from the remote server and writes it
	 */
	public function buildLocalJsonCache()
	{
		/* Now fetch JSON data from the server and write it */
		// require_once( IPS_KERNEL_PATH . 'classFileManagement.php' );/*noLibHook*/
		// $files = new classFileManagement();

		// $json = $files->getFileContents( $this->getJsonUrl() );

		# who you are?

		$response = <<<RESPONSE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RESPONSE;

		$json = base64_decode($response);
		if ( $json )
		{
			$cacheFile = IPS_CACHE_PATH . 'cache/skinGenJsonCache.js';

			if ( file_exists( $cacheFile ) )
			{
				@unlink( $cacheFile );
			}

			file_put_contents( $cacheFile, $json );
			@chmod( $cacheFile, 0777 );
		}
		else
		{
			throw new Exception( "JSON_NOT_RETURNED");
		}

		return true;
	}

	/**
	 * Saves the skin and that
	 * @param	array	css, storedSettings, storedClasses
	 * @param	int		Member Id
	 */
	public function save( array $data, $memberId )
	{
		$session = $this->getUserSession( $memberId );

		if ( empty( $session['sg_session_id'] ) )
		{
			throw new Exception( 'NO_SESSION_FOUND' );
		}

		/* Update session */
		$this->DB->update( 'skin_collections', array( 'set_skin_gen_data' => serialize( $data ) ), 'set_id=\'' . $session['sg_skin_set_id'] . '\''  );

		/* Write CSS_EXISTS extras css */
		try
		{
			$this->saveCSSFromAdd( $session['sg_skin_set_id'], trim( $data['css'] ), 'ipb_skingen', 999, '', 'core' );
		}
		catch( Exception $e )
		{
			if ( $e->getMessage() == 'CSS_EXISTS' )
			{
				$css = $this->fetchCSS( $session['sg_skin_set_id'] );
				$this->saveCSSFromEdit( $css['ipb_skingen']['css_id'], $session['sg_skin_set_id'], trim( $data['css'] ), 'ipb_skingen', 999, '', 'core' );
			}
		}

		/* Update replacements */
		$replacements = $this->fetchReplacements( $session['sg_skin_set_id'] );

		/* Set transparent logo */
		$this->saveReplacementFromEdit( $replacements['logo_img']['replacement_id'], $session['sg_skin_set_id'], '{style_image_url}/logo_transparent.png', 'logo_img' );

		/* Flag for rebuild */
		$this->flagSetForRecache( $session['sg_skin_set_id'] );

		/* Delete session */
		$this->deleteUserSession( $memberId );
	}

	/**
	 * Resets the member's skin
	 * @param	int		Member Id
	 */
	public function resetMemberAndSwitchSkin( $memberId )
	{
		$session = $this->getUserSession( $memberId );

		if ( empty( $session['sg_session_id'] ) )
		{
			throw new Exception( 'NO_SESSION_FOUND' );
		}

		IPSMember::save( $memberId, array( 'core' => array( 'bw_using_skin_gen' => 0, 'skin' => $session['sg_skin_set_id'] ) ) );
	}

	/**
	 * Set a user's session
	 * @param int $memberId
	 * @param array
	 */
	public function setUserSession( $memberId, $data )
	{
		if ( ! empty( $memberId ) AND ! empty( $data['skin_set_id'] ) )
		{
			$sessionKey = md5( uniqid() );

			$this->deleteUserSession( $memberId );

			if ( empty( $data['set_skin_gen_data'] ) )
			{
				$skin = $this->fetchSkinData( $data['skin_set_id'] );

				$data['set_skin_gen_data'] = $skin['set_skin_gen_data'];
			}

			$this->DB->insert( 'skin_generator_sessions', array( 'sg_session_id'  => $sessionKey,
																 'sg_member_id'   => $memberId,
																 'sg_skin_set_id' => $data['skin_set_id'],
																 'sg_date_start'  => IPS_UNIX_TIME_NOW,
																 'sg_data'		  => ( is_array( $data ) ) ? serialize( $data ) : $data  ) );

			/* Flag user */
			IPSMember::save( $memberId, array( 'core' => array( 'bw_using_skin_gen' => 1 ) ) );

			return $sessionKey;
		}
		else
		{
			return false;
		}
	}

	/**
	 * Delete a user's session
	 * @param int $memberId
	 * @param null
	 */
	public function deleteUserSession( $memberId )
	{
		$this->DB->delete( 'skin_generator_sessions', 'sg_member_id=' . intval( $memberId ) );

		/* Flag user */
		IPSMember::save( $memberId, array( 'core' => array( 'bw_using_skin_gen' => 0 ) ) );
	}

	/**
	 * Get a user's session
	 * @param int $memberId
	 */
	public function getUserSession( $memberId )
	{
		$session = $this->DB->buildAndFetch( array( 'select' => '*',
													'from'   => 'skin_generator_sessions',
													'where'  => 'sg_member_id=' . intval( $memberId ) ) );

		if ( ! empty( $session['sg_session_id'] ) )
		{
			if ( IPSLib::isSerialized( $session['sg_data'] ) )
			{
				$session['sg_data_array'] = unserialize( $session['sg_data'] );

				if ( IPSLib::isSerialized( $session['sg_data_array']['set_skin_gen_data'] ) )
				{
					$session['skin_gen_data'] = unserialize( $session['sg_data_array']['set_skin_gen_data'] );
				}
			}

			return $session;
		}
		else
		{
			/* Prevent this from loading again */
			IPSMember::save( $memberId, array( 'core' => array( 'bw_using_skin_gen' => 0 ) ) );

			return false;
		}
	}

	/**
	 * Get a user's session
	 * @param int $skinSetId
	 */
	public function getSessionBySkinId( $skinSetId )
	{
		$session = $this->DB->buildAndFetch( array( 'select' => '*',
													'from'   => 'skin_generator_sessions',
													'where'  => 'sg_skin_set_id=' . intval( $skinSetId ) ) );

		if ( ! empty( $session['sg_session_id'] ) )
		{
			if ( IPSLib::isSerialized( $session['sg_data'] ) )
			{
				$session['sg_data_array'] = unserialize( $session['sg_data'] );

				if ( IPSLib::isSerialized( $session['sg_data_array']['set_skin_gen_data'] ) )
				{
					$session['skin_gen_data'] = unserialize( $session['sg_data_array']['set_skin_gen_data'] );
				}
			}

			return $session;
		}
		else
		{
			return false;
		}
	}


}
