<?php
/**
 * @file		ips.php			API for informing IPB that license data needs to be refreshed - called when license is renewed, etc.
 *
 * $Copyright: $
 * $License: $
 * $Author: mark $
 * $LastChangedDate: 2012-11-09 10:11:12 -0500 (Fri, 09 Nov 2012) $
 * $Revision: 11584 $
 * @since 		22nd February 2012
 */

define( 'IPS_ENFORCE_ACCESS', TRUE );
define( 'IPB_THIS_SCRIPT', 'public' );
require_once( '../initdata.php' );/*noLibHook*/

require_once( IPS_ROOT_PATH . 'sources/base/ipsRegistry.php' );/*noLibHook*/
require_once( IPS_ROOT_PATH . 'sources/base/ipsController.php' );/*noLibHook*/

$registry = ipsRegistry::instance();
$registry->init();

if ( $_GET['cdnCheck'] )
{
	echo 'OK';
	exit;
}
else
{
	# little pussy cat
	if ( ipsRegistry::$settings['ipb_reg_number'] and ipsRegistry::$request['key'] == ipsRegistry::$settings['ipb_reg_number'] )
	{
		switch ( ipsRegistry::$request['do'] )
		{
			case 'reset':
				ipsRegistry::DB()->update( 'cache_store', array( 'cs_rebuild' => 1 ), "cs_key='licenseData'" );
				ipsRegistry::cache()->putWithCacheLib( 'licenseData', 'rebuildCache', 200 );
				break;
			# CDN must allways disabled
			case 'cdnoff':
			case 'cdnon':
				$settings = array( 'ips_cdn' => FALSE, 'ipb_img_url' => '', 'ipb_css_url' => '', 'ipb_js_url' => '', 'upload_url' => '' );
				
				if ( IPSLib::appIsInstalled('downloads') )
				{
					if ( preg_match( '#^http://p(\d+).ipscdn.com#', ipsRegistry::$settings['idm_screenshot_url'] ) )
					{
						$settings['idm_screenshot_url'] = preg_replace( '#^http://p(\d+).ipscdn.com#', ipsRegistry::$settings['board_url'], ipsRegistry::$settings['idm_screenshot_url'] );
					}
				}
				if ( IPSLib::appIsInstalled('gallery') )
				{
					if ( preg_match( '#^http://p(\d+).ipscdn.com#', ipsRegistry::$settings['gallery_images_url'] ) )
					{
						$settings['gallery_images_url'] = preg_replace( '#^http://p(\d+).ipscdn.com#', ipsRegistry::$settings['board_url'], ipsRegistry::$settings['gallery_images_url'] );
					}
				}
							
				IPSLib::updateSettings( $settings );
				echo "OK";
				break;
				
				// $settings = array( 'ips_cdn' => TRUE, 'ipb_img_url' => ipsRegistry::$request['url'], 'ipb_css_url' => ipsRegistry::$request['url'], 'ipb_js_url' => ipsRegistry::$request['url'], 'upload_url' => ipsRegistry::$request['url'] . '/uploads' );
				// if ( IPSLib::appIsInstalled('downloads') )
				// {
				// 	if ( substr( ipsRegistry::$settings['idm_localsspath'], 0, 11 ) === '{root_path}' )
				// 	{
				// 		$settings['idm_screenshot_url'] = str_replace( '{root_path}', ipsRegistry::$request['url'], ipsRegistry::$settings['idm_localsspath'] );
				// 	}
				// }
				// if ( IPSLib::appIsInstalled('gallery') )
				// {
				// 	$this_script = str_replace( '\\', '/', getenv( 'SCRIPT_FILENAME' ) );
				// 	if( $this_script )
				// 	{
				// 		$this_script = str_replace( '/'.CP_DIRECTORY.'/index.php', '', $this_script );
				// 		if ( substr( ipsRegistry::$settings['gallery_images_path'], 0, strlen( $this_script ) ) === $this_script )
				// 		{
				// 			$settings['gallery_images_url'] = str_replace( '\\', '/', str_replace( $this_script, ipsRegistry::$request['url'], ipsRegistry::$settings['gallery_images_path'] ) );
				// 		}
				// 	}
				// }
			
				// IPSLib::updateSettings( $settings );
				
				// if ( ipsRegistry::$settings['ips_cdn'] )
				// {
				// 	echo "OK";
				// }
				// else
				// {
				// 	echo "FLUSH";
				// }
				// break;
		}
	}
}


exit;
